/*
This code is released under the MIT License <http://www.opensource.org/licenses/mit-license.php> 
*/

package ena{
	import flash.display.Sprite;
	import flash.errors.IOError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SampleDataEvent;
	import flash.external.ExternalInterface;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundLoaderContext;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;
	
	import mx.controls.Alert;
	import mx.core.IMXMLObject;
	import mx.core.UIComponent;
	import mx.events.Request;
	
	import spark.skins.spark.mediaClasses.fullScreen.FullScreenButtonSkin;

	public class mp3player{
		
		//サウンド操作用変数
		private var sound:Array =  new Array(1);
		private var soundch:SoundChannel = null;
		private var soundtr:SoundTransform = new SoundTransform();
		
		//各種コールバック
		private var loading_call:Function = function():void{};
		private var playing_call:Function = function():void{};
		private var always_call:Function  = function():void{};
		
		//拡張機能用変数
		private var startTime:int = 0;
		private var endTime:int = -1;
		private var loopNum:int = 0;
		private var autoStart_flg:Boolean = false;
		private var isStop_flg:Boolean = true;
		
		//再生終了用コールバックとスプライト
		private var play_sprite:Sprite = new Sprite();
		private function internal_stop(event:Event):void{
			if( (endTime>=0 && getPosition()>=endTime) || getPosition()>=length()-1) decrease();
		}
		private function internal_start(event:ProgressEvent):void{
			if(autoStart_flg && length() >= startTime && isStop()) play();
		}
		private function internal_decrease(e:Event):void{
			decrease();
		}
		
		//constructer
		public function mp3player(){
			soundtr.volume = 1;
			play_sprite.addEventListener(Event.ENTER_FRAME,always_call);
		}
		
		//destructer
		public function destroy():void{
			stop();
			delete sound[0];
		}
		
		
		public function load(url:String):Boolean{
			var req:URLRequest = new URLRequest(encodeURI(url));
			var context:SoundLoaderContext = new SoundLoaderContext(250, false);
			
			stop();
			soundch = null;
			if(sound[0]){
				sound[0].removeEventListener(ProgressEvent.PROGRESS,loading_call);
				sound[0].removeEventListener(ProgressEvent.PROGRESS,internal_start);
				delete sound[0];
			}
			
			sound[0] = new Sound();
			sound[0].addEventListener(IOErrorEvent.IO_ERROR,
				function(event:IOErrorEvent):void{
					delete sound[0];
					sound[0] = null;
				}
			);
			sound[0].addEventListener(Event.COMPLETE,
				function(event:Event):void{
					sound[0].removeEventListener(ProgressEvent.PROGRESS,loading_call);
					sound[0].removeEventListener(ProgressEvent.PROGRESS,internal_start);
				}
			);
			sound[0].addEventListener(Event.OPEN,
				function(event:Event):void{
					sound[0].addEventListener(ProgressEvent.PROGRESS,loading_call);
					sound[0].addEventListener(ProgressEvent.PROGRESS,internal_start);
				}
			);
			try{sound[0].load(req,context);}catch(err:Error){Alert.show(err.message);}
			
			return true;
		}
		
		
		public function play():Boolean{
			if(!sound[0])return false;
			sound[0].removeEventListener(ProgressEvent.PROGRESS,internal_start);
			
			stop();
			play_sprite.addEventListener(Event.ENTER_FRAME,playing_call);
			play_sprite.addEventListener(Event.ENTER_FRAME,internal_stop);
			soundch = sound[0].play(startTime,0,soundtr);
			soundch.addEventListener(Event.SOUND_COMPLETE,internal_decrease);
			isStop_flg = false;
			return true;
		}
		
		public function stop():Boolean{
			if(!soundch)return false;
			
			soundch.stop();
			play_sprite.removeEventListener(Event.ENTER_FRAME,playing_call);
			play_sprite.removeEventListener(Event.ENTER_FRAME,internal_stop);
			soundch.removeEventListener(Event.SOUND_COMPLETE,internal_decrease);
			isStop_flg = true;
			return true;
		}
		
		public function restart():Boolean{
			stop();
			setPosition(startTime);
			return play();
		}
		
		public function decrease():Boolean{
			stop();
			setPosition(startTime);
			if(loopNum!=0){
				if(loopNum>0) loopNum--;
				return play();
			}
			return false;
		}
		
		public function toggle():Boolean{
			if(isStop()){
				var pos:int = getPosition();
				play();
				setPosition(pos);
			}
			else stop();
			return true;
		}
			
		//write and read method
		public function setVolume(vol:Number):void{
			soundtr.volume=vol;
			if(!soundch) return;
			soundch.soundTransform=soundtr;
		}
		public function getVolume():Number{ return soundtr.volume; }
		public function setCallback_loading(func:Function):void{
			if(sound[0]){
				sound[0].removeEventListener(ProgressEvent.PROGRESS,loading_call);
				sound[0].addEventListener(ProgressEvent.PROGRESS,func);
			}
			loading_call = func;
		}
		public function getCallback_loading():Function{ return loading_call; }
		public function setCallback_playing(func:Function):void{
			if(!isStop()){
				play_sprite.removeEventListener(Event.ENTER_FRAME,playing_call);
				play_sprite.addEventListener(Event.ENTER_FRAME,func);
			}
			playing_call = func;
		}
		public function getCallback_playing():Function{ return playing_call; }
		public function setCallback_always(func:Function):void{
			play_sprite.removeEventListener(Event.ENTER_FRAME,always_call);
			play_sprite.addEventListener(Event.ENTER_FRAME,func);
			always_call = func;
		}
		public function getCallback_always():Function{ return always_call; }
		public function setPosition(start:int):Boolean{
			if(!soundch)return false;
			
			if(start < startTime)start = startTime;
			if(!isStop())soundch.stop();
			soundch = sound[0].play(start,loopNum,soundtr);
			if(isStop()){
				while(start>0&&length()>0&&soundch.position==0){}
				soundch.stop();
			}
			return true;
		}
		public function getPosition():int{ if(!soundch)return -1; return soundch.position; }
		public function setStartTime(start:int):void{
			if(start<0){
				if(!soundch) start = 0;
				else start = int(soundch.position);
			}
			startTime=start;
		}
		public function getStartTime():int{ return startTime; }
		public function setEndTime(end:int):void{ endTime=end; }
		public function getEndTime():int{ return endTime; }
		public function setLoopNum(loop:int):void{ loopNum=loop; }
		public function getLoopNum():int{ return loopNum; }
		public function setAutoStart(flg:Boolean):void{ autoStart_flg=flg; }
		public function getAutoStart():Boolean{ return autoStart_flg; }
		
		//read only
		public function bytesLoaded():int{ if(!sound[0])return -1;	return sound[0].bytesLoaded;}
		public function bytesTotal():int{ if(!sound[0])return -1;	return sound[0].bytesTotal; }
		public function length():int{ if(!sound[0])return -1;	return sound[0].length; }
		public function url():String{ if(!sound[0])return ""; return sound[0].url; }
		public function isStop():Boolean{ return isStop_flg; }

		
	}
	
	

	
	
}