﻿/*
This code is released under the MIT License <http://www.opensource.org/licenses/mit-license.php> 
*/

package ena{
	import flash.display.Sprite;
	import flash.errors.IOError;
	import flash.events.AsyncErrorEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.NetStatusEvent;
	import flash.events.ProgressEvent;
	import flash.events.SampleDataEvent;
	import flash.external.ExternalInterface;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundLoaderContext;
	import flash.media.SoundTransform;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.URLRequest;
	
	import mx.controls.Alert;
	import mx.core.IMXMLObject;
	import mx.core.INavigatorContent;
	import mx.core.UIComponent;
	import mx.events.Request;
	
	import spark.skins.spark.mediaClasses.fullScreen.FullScreenButtonSkin;

	public class mp4player{
		
		//サウンド操作用変数
		private var req:URLRequest = null;
		private var sound:Array =  new Array(1);
		private var soundtr:SoundTransform = new SoundTransform();
		private var length_val:int = -1;
		private var load_flg:int;
		
		//各種コールバック
		private var loading_call:Function = function():void{};
		private var playing_call:Function = function():void{};
		private var always_call:Function  = function():void{};
		
		//拡張機能用変数
		private var startTime:int = 0;
		private var endTime:int = -1;
		private var loopNum:int = 0;
		private var autoStart_flg:Boolean = false;
		private var isStop_flg:Boolean = true;
		
		//再生終了用コールバックとスプライト
		private var play_sprite:Sprite = new Sprite();
		private function internal_stopafter(event:Event):void{
			if( endTime!=-1 && startTime>endTime ) stop();
			else if( getPosition() < endTime ){
				play_sprite.removeEventListener(Event.ENTER_FRAME,internal_stopafter);
				play_sprite.addEventListener(Event.ENTER_FRAME,internal_stop);
			}
		}
		private function internal_stop(event:Event):void{
			if( endTime>=0 && getPosition()>=endTime ){
				decrease();
				play_sprite.removeEventListener(Event.ENTER_FRAME,internal_stop);
				play_sprite.addEventListener(Event.ENTER_FRAME,internal_stopafter);
			}
		}
		private function internal_always(event:Event):void{
			if( bytesLoaded() != bytesTotal() )
				loading_call( new ProgressEvent(ProgressEvent.PROGRESS,false,false,bytesLoaded(),bytesTotal()) );
		}
		
		//constructer
		public function mp4player(){
			soundtr.volume = 1;
			play_sprite.addEventListener(Event.ENTER_FRAME,always_call);
			play_sprite.addEventListener(Event.ENTER_FRAME,internal_stop);
			play_sprite.addEventListener(Event.ENTER_FRAME,internal_always);
		}

		//destructer
		public function destroy():void{
			stop();
			delete sound[0];
		}
		
		public function load(url:String):Boolean{
			req = new URLRequest(encodeURI(url));
			
			if(!sound[0]){
				var nc:NetConnection = new NetConnection();
				nc.connect(null);
				sound[0] = new NetStream(nc);
				
				
				sound[0].client = this;
				sound[0].addEventListener(AsyncErrorEvent.ASYNC_ERROR,
					function(event:AsyncErrorEvent):void{
						//Alert.show("再生時に何らかのエラーが発生したみたいですけど無視します");
					}
				);
				sound[0].addEventListener(IOErrorEvent.IO_ERROR,
					function(event:IOErrorEvent):void{
						delete sound[0];
						sound[0] = null;
					}
				);
				sound[0].addEventListener(NetStatusEvent.NET_STATUS, 
					function netStatusHandler(event:NetStatusEvent):void {
						switch (event.info.code) {/*
							case "NetConnection.Connect.Success":
							break;
							case "NetStream.Play.StreamNotFound":
							break;
							*/
							case "NetStream.Seek.Notify":
								//Alert.show("seek notify");
								//for( var key:String in event.info ) Alert.show("info["+key+"]="+event.info[key].toString());
								break;
							case "NetStream.Seek.InvalidTime":
								//Alert.show(event.info.code);
								//for( var key:String in event.info ) Alert.show("info["+key+"]="+event.info[key].toString());
								break;
							case "NetStream.Play.Start":
								break;
							case "NetStream.Buffer.Full":
								break;
							case "NetStream.Play.Stop":
								decrease();
								break;
							default:
								//Alert.show(event.info.code);
								//for( key in event.info ) Alert.show("info["+key+"]="+event.info[key].toString());
						}
					}
				);
			}
			else stop();

			load_flg = 1;
			isStop_flg = false;
			sound[0].play(req.url);

			return true;
		}
		
		
		public function play():Boolean{
			if(!sound[0])return false;

			setPosition(startTime);
			if(!isStop())return true;

			
			play_sprite.addEventListener(Event.ENTER_FRAME,playing_call);
			sound[0].resume();
			sound[0].soundTransform = soundtr;

			isStop_flg = false;

			return true;
		}
		
		public function stop():Boolean{
			if(!sound[0])return false;

			setPosition(startTime);
			if(isStop())return true;

			sound[0].pause();
			play_sprite.removeEventListener(Event.ENTER_FRAME,playing_call);

			isStop_flg = true;
			return true;
		}
		
		public function restart():Boolean{
			return play();
		}
		
		public function decrease():Boolean{
			if(loopNum!=0){
				if(loopNum>0) loopNum--;
				return play();
			}
			return stop();
		}
		
		public function toggle():Boolean{
			if(!sound[0]) return false;

			sound[0].togglePause();
			isStop_flg = !isStop_flg;
			return true;
		}
			
		//write and read method
		public function setVolume(vol:Number):void{
			soundtr.volume=vol;
			if(!sound[0]) return;
			sound[0].soundTransform=soundtr;
		}
		public function getVolume():Number{ return soundtr.volume; }
		public function setCallback_loading(func:Function):void{
			loading_call = func;
		}
		public function getCallback_loading():Function{ return loading_call; }
		public function setCallback_playing(func:Function):void{
			if(!isStop()){
				play_sprite.removeEventListener(Event.ENTER_FRAME,playing_call);
				play_sprite.addEventListener(Event.ENTER_FRAME,func);
			}
			playing_call = func;
		}
		public function getCallback_playing():Function{ return playing_call; }
		public function setCallback_always(func:Function):void{
			play_sprite.removeEventListener(Event.ENTER_FRAME,always_call);
			play_sprite.addEventListener(Event.ENTER_FRAME,func);
			always_call = func;
		}
		public function getCallback_always():Function{ return always_call; }
		public function setPosition(start:Number):Boolean{
			if(!sound[0])return false;
			
			if(start < startTime)start = startTime;
			sound[0].seek(start/1000);
			return true;
		}
		public function getPosition():int{ if(!sound[0])return -1; return sound[0].time*1000; }
		public function setStartTime(start:int):void{
			if(start<0){
				start = getPosition();
				if(start<0) start = 0;
			}
			startTime=start;
			if(getPosition()<startTime)play();
		}
		public function getStartTime():int{ return startTime; }
		public function setEndTime(end:int):void{ endTime=end; }
		public function getEndTime():int{ return endTime; }
		public function setLoopNum(loop:int):void{ loopNum=loop; }
		public function getLoopNum():int{ return loopNum; }
		public function setAutoStart(flg:Boolean):void{ autoStart_flg=flg; }
		public function getAutoStart():Boolean{ return autoStart_flg; }
		
		//read only
		public function bytesLoaded():int{ if(!sound[0])return -1;	return sound[0].bytesLoaded;}
		public function bytesTotal():int{ if(!sound[0])return -1;	return sound[0].bytesTotal; }
		public function length():int{ return length_val; }
		public function url():String{ if(!req)return ""; return req.url; }
		public function isStop():Boolean{ return isStop_flg; }

		//特別な関数
		public function setVideo(video:Video):void{
			video.attachNetStream(sound[0]);
			return;
		}

		//イベントハンドラ
		public function onMetaData(info:Object):void{
			length_val = info.duration*1000;
			
			//ロードが終わり、メタデータを読み終わってから再生したり停止したりする。
			if(load_flg==1){
				load_flg=0;	
				if(autoStart_flg) play();
				else stop();
			}
			
			return;
		};

		
	}
	
	

	
	
}